import {FireAuditUtil} from './services/fireaudit.util';


/**
 * FireAudit can do more than just track history. It can audit changes in your data to see if there are any anomalies.
 * For this, you can configure various _sensors_, some of these sensors need metadata.
 * To get the most value out of FireAudit there is a `fireAudit` property that should be used on all documents.
 * FireAudit uses this property to track **which** users does **what**, **when** and **why**.
 */
export interface FireAuditMetadata {
    /**
     * Strongly recommended, The UID of the user causing this change, use `FUNCTION` when a function causes a change and no specific user must be tagged.
     */
    uid?: string;

    /**
     * Strongly recommended, The reason why the changed occurs, this typically is the name of the class that caused the change, or the name of the trigger.
     */
    event?: string;

    /**
     * Strongly recommended, The time of receiving in firestore, use FieldValue.serverTimestamp().
     */
    serverTime?: Date;

    /**
     * Optional, a field to indicate the time on the users’ device.
     */
    userTime?: Date;

    /**
     * Optional, a flag to mark this document for deletion. Use this when you want to delete a file, but want to keep the UID information. When set to true this document will be deleted after FireAudit has logged it.
     */
    delete?: boolean;

    /**
     * Optional, user-defined properties.
     */
    [prop: string]: any;

    /**
     * Internally used by FireAudit, will be set automatically, can be ignored.
     */
    path?: string;
}

/**
 * Convenience interface for any model type.
 */
export interface FireAuditMetadataContainer {
    fireAudit?: FireAuditMetadata;
}

export interface FireAuditOptions {
    /**
     * Mandatory: How many levels of collection/document nesting does your deepest firestore path have.
     */
    levels: number;

    /**
     * Mandatory: The domain of FireAudit, either EU or US, or possibly a custom domain for enterprise usage.
     */
    domain: 'EU' | 'US' | string;

    /**
     * Optional: The highest collection that FireAudit must monitor. When omitted, FireAudit will monitor everything.
     */
    root?: string;

    /**
     * Optional: The region to deploy the FireAudit functions. Use multiple configurations when you must deploy into multiple regions.
     * Defaults to europe-west1.
     */
    region?: 'us-central1' | 'us-east1' | 'us-east4' | 'europe-west1' | 'europe-west2' | 'asia-east2' | 'asia-northeast1';

    /**
     * Mandatory: The API key generated by FireAudit for your project, see https://console.fireaudit.studio for more.
     */
    apiKey: string;

    /**
     * Optional: A transformer function to transform any data before FireAudit processes it. Possible use-cases are
     * data anonymisation, or exclusion of specific paths. When omitted, all data is processed.
     * @param data: The data which could be anonymised, or pre-processed,
     * @param path: The path of the data.
     * @return Processed data, or null when FireAudit should ignore this change completely.
     */
    transformer?: (data: any, path: string, util: FireAuditUtil) => FireAuditMetadataContainer | unknown;

    /**
     * Optional: The following settings are only mandatory when using client-side hashing.
     */
    hashing?: {
        /**
         * Mandatory: Salt for hashing strings.
         */
        sha512Salt: string;
    };

    /**
     * Optional: The following settings are only mandatory when using client-side symmetric encryption.
     */
    encryption?: {
        /**
         * Mandatory: Key for encryption. Please use a lengthy, random string, instead of a short word.
         */
        encryptionPassword: string;

        /**
         * Optional: Keys for decryption. Can be used to update the encryption password, but still allow decrypting old data.
         * By default, the encryptionPassword is added to the list of decryptionPasswords.
         */
        decryptionPasswords?: string[];
    };

    /**
     * Optional: Disables deleting documents when fireAudit.delete is true.
     */
    disableDelete?: boolean;
}
